//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class Platform : global::System.IDisposable {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal Platform(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(Platform obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~Platform() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_Platform(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }

  public virtual string getName() {
    string ret = OpenMMSwigPINVOKE.Platform_getName(swigCPtr);
    return ret;
  }

  public virtual double getSpeed() {
    double ret = OpenMMSwigPINVOKE.Platform_getSpeed(swigCPtr);
    return ret;
  }

  public virtual bool supportsDoublePrecision() {
    bool ret = OpenMMSwigPINVOKE.Platform_supportsDoublePrecision(swigCPtr);
    return ret;
  }

  public SWIGTYPE_p_std__vectorT_std__string_t getPropertyNames() {
    SWIGTYPE_p_std__vectorT_std__string_t ret = new SWIGTYPE_p_std__vectorT_std__string_t(OpenMMSwigPINVOKE.Platform_getPropertyNames(swigCPtr), false);
    return ret;
  }

  public virtual string getPropertyValue(Context context, string property) {
    string ret = OpenMMSwigPINVOKE.Platform_getPropertyValue(swigCPtr, Context.getCPtr(context), property);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public virtual void setPropertyValue(Context context, string property, string value) {
    OpenMMSwigPINVOKE.Platform_setPropertyValue(swigCPtr, Context.getCPtr(context), property, value);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public string getPropertyDefaultValue(string property) {
    string ret = OpenMMSwigPINVOKE.Platform_getPropertyDefaultValue(swigCPtr, property);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void setPropertyDefaultValue(string property, string value) {
    OpenMMSwigPINVOKE.Platform_setPropertyDefaultValue(swigCPtr, property, value);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public virtual void contextCreated(SWIGTYPE_p_OpenMM__ContextImpl context, map_string_string properties) {
    OpenMMSwigPINVOKE.Platform_contextCreated(swigCPtr, SWIGTYPE_p_OpenMM__ContextImpl.getCPtr(context), map_string_string.getCPtr(properties));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public virtual void linkedContextCreated(SWIGTYPE_p_OpenMM__ContextImpl context, SWIGTYPE_p_OpenMM__ContextImpl originalContext) {
    OpenMMSwigPINVOKE.Platform_linkedContextCreated(swigCPtr, SWIGTYPE_p_OpenMM__ContextImpl.getCPtr(context), SWIGTYPE_p_OpenMM__ContextImpl.getCPtr(originalContext));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public virtual void contextDestroyed(SWIGTYPE_p_OpenMM__ContextImpl context) {
    OpenMMSwigPINVOKE.Platform_contextDestroyed(swigCPtr, SWIGTYPE_p_OpenMM__ContextImpl.getCPtr(context));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void registerKernelFactory(string name, SWIGTYPE_p_OpenMM__KernelFactory factory) {
    OpenMMSwigPINVOKE.Platform_registerKernelFactory(swigCPtr, name, SWIGTYPE_p_OpenMM__KernelFactory.getCPtr(factory));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public bool supportsKernels(SWIGTYPE_p_std__vectorT_std__string_t kernelNames) {
    bool ret = OpenMMSwigPINVOKE.Platform_supportsKernels(swigCPtr, SWIGTYPE_p_std__vectorT_std__string_t.getCPtr(kernelNames));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public SWIGTYPE_p_OpenMM__Kernel createKernel(string name, SWIGTYPE_p_OpenMM__ContextImpl context) {
    SWIGTYPE_p_OpenMM__Kernel ret = new SWIGTYPE_p_OpenMM__Kernel(OpenMMSwigPINVOKE.Platform_createKernel(swigCPtr, name, SWIGTYPE_p_OpenMM__ContextImpl.getCPtr(context)), true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public static void registerPlatform(Platform platform) {
    OpenMMSwigPINVOKE.Platform_registerPlatform(Platform.getCPtr(platform));
  }

  public static int getNumPlatforms() {
    int ret = OpenMMSwigPINVOKE.Platform_getNumPlatforms();
    return ret;
  }

  public static Platform getPlatform(int index) {
    Platform ret = new Platform(OpenMMSwigPINVOKE.Platform_getPlatform(index), false);
    return ret;
  }

  public static SWIGTYPE_p_std__vectorT_std__string_t getPluginLoadFailures() {
    SWIGTYPE_p_std__vectorT_std__string_t ret = new SWIGTYPE_p_std__vectorT_std__string_t(OpenMMSwigPINVOKE.Platform_getPluginLoadFailures(), true);
    return ret;
  }

  public static Platform getPlatformByName(string name) {
    Platform ret = new Platform(OpenMMSwigPINVOKE.Platform_getPlatformByName(name), false);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public static Platform findPlatform(SWIGTYPE_p_std__vectorT_std__string_t kernelNames) {
    Platform ret = new Platform(OpenMMSwigPINVOKE.Platform_findPlatform(SWIGTYPE_p_std__vectorT_std__string_t.getCPtr(kernelNames)), false);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public static void loadPluginLibrary(string file) {
    OpenMMSwigPINVOKE.Platform_loadPluginLibrary(file);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public static SWIGTYPE_p_std__vectorT_std__string_t loadPluginsFromDirectory(string directory) {
    SWIGTYPE_p_std__vectorT_std__string_t ret = new SWIGTYPE_p_std__vectorT_std__string_t(OpenMMSwigPINVOKE.Platform_loadPluginsFromDirectory(directory), true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public static string getDefaultPluginsDirectory() {
    string ret = OpenMMSwigPINVOKE.Platform_getDefaultPluginsDirectory();
    return ret;
  }

  public static string getOpenMMVersion() {
    string ret = OpenMMSwigPINVOKE.Platform_getOpenMMVersion();
    return ret;
  }

}

}
